// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <goocanvasmm/imagemodel.h>
#include <goocanvasmm/private/imagemodel_p.h>


/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasimage.h>


namespace Goocanvas
{

//TODO: Reimplement goo_canvas_image_new()
ImageModel::ImageModel(double x, double y)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemModelSimple(Glib::ConstructParams(imagemodel_class_.init(), "x",x,"y",y, static_cast<char*>(0)))
{
}

ImageModel::ImageModel(const Glib::RefPtr<Gdk::Pixbuf>& pixbuf, double x, double y)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemModelSimple(Glib::ConstructParams(imagemodel_class_.init(), "pixbuf",pixbuf->gobj(),"x",x,"y",y, static_cast<char*>(0)))
{
}

} //namespace Goocanvas


namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Goocanvas::ImageModel> wrap(GooCanvasImageModel* object, bool take_copy)
{
  return Glib::RefPtr<Goocanvas::ImageModel>( dynamic_cast<Goocanvas::ImageModel*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Goocanvas
{


/* The *_Class implementation: */

const Glib::Class& ImageModel_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &ImageModel_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(goo_canvas_image_model_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void ImageModel_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* ImageModel_Class::wrap_new(GObject* object)
{
  return new ImageModel((GooCanvasImageModel*)object);
}


/* The implementation: */

GooCanvasImageModel* ImageModel::gobj_copy()
{
  reference();
  return gobj();
}

ImageModel::ImageModel(const Glib::ConstructParams& construct_params)
:
  Goocanvas::ItemModelSimple(construct_params)
{

}

ImageModel::ImageModel(GooCanvasImageModel* castitem)
:
  Goocanvas::ItemModelSimple((GooCanvasItemModelSimple*)(castitem))
{}


ImageModel::ImageModel(ImageModel&& src) noexcept
: Goocanvas::ItemModelSimple(std::move(src))
{}

ImageModel& ImageModel::operator=(ImageModel&& src) noexcept
{
  Goocanvas::ItemModelSimple::operator=(std::move(src));
  return *this;
}

ImageModel::~ImageModel() noexcept
{}


ImageModel::CppClassType ImageModel::imagemodel_class_; // initialize static member

GType ImageModel::get_type()
{
  return imagemodel_class_.init().get_type();
}


GType ImageModel::get_base_type()
{
  return goo_canvas_image_model_get_type();
}


Glib::RefPtr<ImageModel> ImageModel::create(const Glib::RefPtr<Gdk::Pixbuf>& pixbuf, double x, double y)
{
  return Glib::RefPtr<ImageModel>( new ImageModel(pixbuf, x, y) );
}

Glib::RefPtr<ImageModel> ImageModel::create(double x, double y)
{
  return Glib::RefPtr<ImageModel>( new ImageModel(x, y) );
}

ImageModel::ImageModel()
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemModelSimple(Glib::ConstructParams(imagemodel_class_.init()))
{
  

}


Glib::PropertyProxy< Cairo::RefPtr<Cairo::Pattern> > ImageModel::property_pattern() 
{
  return Glib::PropertyProxy< Cairo::RefPtr<Cairo::Pattern> >(this, "pattern");
}

Glib::PropertyProxy_ReadOnly< Cairo::RefPtr<Cairo::Pattern> > ImageModel::property_pattern() const
{
  return Glib::PropertyProxy_ReadOnly< Cairo::RefPtr<Cairo::Pattern> >(this, "pattern");
}

Glib::PropertyProxy< bool > ImageModel::property_scale_to_fit() 
{
  return Glib::PropertyProxy< bool >(this, "scale-to-fit");
}

Glib::PropertyProxy_ReadOnly< bool > ImageModel::property_scale_to_fit() const
{
  return Glib::PropertyProxy_ReadOnly< bool >(this, "scale-to-fit");
}

Glib::PropertyProxy_WriteOnly< Glib::RefPtr<Gdk::Pixbuf> > ImageModel::property_pixbuf() 
{
  return Glib::PropertyProxy_WriteOnly< Glib::RefPtr<Gdk::Pixbuf> >(this, "pixbuf");
}


} // namespace Goocanvas


